#!/bin/sh
# /www/cgi-bin/ponte2.cgi 

cat <<EOF
Content-type: text/html
<HTML><HEAD><TITLE>ponte2fon - return page</TITLE>

<style type="text/css">
body {
   background-color: #000000;
   font-family: monospace;
   font-weight: bold;
   font-size: 10pt;
   margin-left: 1%; margin-right: 2%;
   color: white;
}

</style>
</HEAD>
<BODY>
please, don't worry be patient...
<pre>
EOF


get_parameter () {
  echo "$query" | tr '&' '\n' | grep "^$1=" | head -1 | sed "s/.*=//" 
}

oggi=$(date)
noMac="--:--:--:--:--:--"
confDir="/etc"

# discover request method
if [ "$REQUEST_METHOD" = POST ]; then
  query=$( head --bytes="$CONTENT_LENGTH" )
  else
  query="$QUERY_STRING"
fi

##### 
with_Profile=0
with_Simlink=0
main_conf=$confDir/ponte2fon.conf
run_string=/etc/ponte2fon
# read inputs
wp=$( get_parameter wp )
profileName=$( get_parameter profileName )
if [ -n "$wp" ]; then
  if [ -n "$profileName" ]; then
    with_Profile=1
    main_conf=$confDir/ponte2fon_$profileName.conf
    run_string="/etc/ponte2fon -p $profileName"
  else
    echo "ERROR: profile name not found"
    exit 1
  fi
  else
  with_Profile=0
fi  

simlink=$( get_parameter simlink )
if [ -n "$simlink" ]; then
  with_Simlink=1
fi

wrapper=$( get_parameter wrapper )
if [ $wrapper == 3 ]; then
  oldProfileName=$( get_parameter oldProfileName )
  if [ -n "$oldProfileName" ]; then
    main_conf=$confDir/ponte2fon_$oldProfileName.conf
    run_string="/etc/ponte2fon -p $oldProfileName"
    cleanWrap=/tmp/wrapper_ponte2fon.sh
    cat > $cleanWrap << EOF
#!/bin/sh
# run $run_string
$run_string
EOF
    chmod 755 $cleanWrap
    exec $cleanWrap  
    else
    echo "ERROR: old profile name not found"
    exit 1
  fi
fi
##### go !
echo "# $main_conf" > $main_conf
echo "#" >> $main_conf
echo "# ath1 parameters" >> $main_conf
echo "#----------------" >> $main_conf
ath1_mode=$( get_parameter p9 )
echo "ath1_mode="$ath1_mode >> $main_conf
case $ath1_mode in
  2) 
  Target_AP=$( get_parameter p10 )
  if ! [ -n "$Target_AP" ]; then
    echo "ERROR: Source Master SSID not indicated"
    exit 1
  fi  
  echo "Target_AP="$Target_AP >> $main_conf
  ;;
  3)
  tm0=$( get_parameter tm0 )
  tm1=$( get_parameter tm1 )
  tm2=$( get_parameter tm2 )
  tm3=$( get_parameter tm3 )
  tm4=$( get_parameter tm4 )
  tm5=$( get_parameter tm5 )
  Target_AP=$tm0:$tm1:$tm2:$tm3:$tm4:$tm5 
  if [ $Target_AP == $noMac ] ; then
    echo "ERROR: Source Master MAC address not valid"
    exit 1  
  fi
  echo "Target_AP="$Target_AP >> $main_conf
  ;;
esac
echo "#" >> $main_conf
echo "# WEP and WPA parameters" >> $main_conf
echo "#-----------------------" >> $main_conf
# WEP
kwepSta=$( get_parameter p22 )
if [ $kwepSta == 1 ] ; then
  WepKey_ath1=$( get_parameter p11a )
  echo "WepKey_ath1="$WepKey_ath1 >> $main_conf
fi
# WPA
kwpa=$( get_parameter p23 )
echo "kwpa="$kwpa >> $main_conf
if ! [ $kwpa == 0 ]; then
  WapPassPhrase=$( get_parameter p24 )
  p23wa=$( get_parameter p23wa )
  case $p23wa in
    1) WapAlg=TKIP ;;
    2) WapAlg=CCMP ;;
    3) WapAlg="TKIP CCMP";;
  esac
  WapSsid=$( get_parameter p10 )
  echo "WapAlg="$WapAlg >> $main_conf
  echo "WapPassPhrase="$WapPassPhrase >> $main_conf
  echo "WapSsid="$WapSsid >> $main_conf
  kwepSta=3
fi
echo "kwepSta="$kwepSta >> $main_conf
echo "#"
echo "# FON HotSpot" >> $main_conf
echo "#--------" >> $main_conf
fonHotSpot=$( get_parameter fon )
echo "fonHotSpot="$fonHotSpot >> $main_conf
echo "rate=256" >> $main_conf
FON_ch=$( get_parameter FON_ch )
echo "FON_ch="$FON_ch >> $main_conf
echo "#" >> $main_conf
echo "# have fun! " >> $main_conf

chmod 755 $main_conf
sleep 1

# run options control
if [ $with_Simlink == 1 ]; then
  cleanWrap=/etc/init.d/S98ponte2
  cat > $cleanWrap << EOF
#!/bin/sh
$run_string
EOF
  chmod 755 $cleanWrap
fi

case $wrapper in
  1) 
  cleanWrap=/tmp/wrapper_ponte2wb.sh
  cat > $cleanWrap << EOF
#!/bin/sh
# run $run_string
$run_string
EOF
  chmod 755 $cleanWrap
  exec $cleanWrap  
  ;;
  2)
  cat $main_conf
  ;;
esac

cat <<EOF
Content-type: text/html
</pre>
</body></html>
EOF

# have fun!



